#include <extdll.h>
#include <dllapi.h>
#include <meta_api.h>

#include "webmod.h"
#include "msg.h"

DLL_FUNCTIONS gFunctionTable;
enginefuncs_t meta_engfuncs;
//msgfuncs_t meta_msgfuncs;

C_DLLEXPORT int
GetEntityAPI2 (DLL_FUNCTIONS * pFunctionTable, int *interfaceVersion)
{
  if (!pFunctionTable)
    {
      UTIL_LogPrintf ("GetEntityAPI2 called with null pFunctionTable");
      return (FALSE);
    }
  else if (*interfaceVersion != INTERFACE_VERSION)
    {
      UTIL_LogPrintf ("GetEntityAPI2 version mismatch; requested=%d ours=%d",
		      *interfaceVersion, INTERFACE_VERSION);
      //! Tell engine what version we had, so it can figure out who is out of date.
      *interfaceVersion = INTERFACE_VERSION;
      return (FALSE);
    }
  memset (&gFunctionTable, 0, sizeof (gFunctionTable));
  gFunctionTable.pfnServerActivate = ServerActivate;
  gFunctionTable.pfnClientConnect = handleClientConnect;
  gFunctionTable.pfnStartFrame = myFrame;
  gFunctionTable.pfnClientPutInServer = clientPutInServer;
  gFunctionTable.pfnClientDisconnect = clientDisconnect;

  memcpy (pFunctionTable, &gFunctionTable, sizeof (DLL_FUNCTIONS));

  return (TRUE);
}

C_DLLEXPORT int
GetEntityAPI2_Post (DLL_FUNCTIONS * pFunctionTable, int *interfaceVersion)
{
  if (!pFunctionTable)
    {
      UTIL_LogPrintf ("GetEntityAPI2_Post called with null pFunctionTable");
      return (FALSE);
    }
  else if (*interfaceVersion != INTERFACE_VERSION)
    {
      UTIL_LogPrintf ("GetEntityAPI2_Post version mismatch; requested=%d ours=%d",
		      *interfaceVersion, INTERFACE_VERSION);
      //! Tell engine what version we had, so it can figure out who is out of date.
      *interfaceVersion = INTERFACE_VERSION;
      return (FALSE);
    }
  memset (&gFunctionTable, 0, sizeof (gFunctionTable));

  gFunctionTable.pfnServerActivate = ServerActivate_Post;

  memcpy (pFunctionTable, &gFunctionTable, sizeof (DLL_FUNCTIONS));

  return (TRUE);
}

C_DLLEXPORT int
GetEngineFunctions (enginefuncs_t * pengfuncsFromEngine,
		    int *interfaceVersion)
{
  LOG_DEVELOPER (PLID, "called: GetEngineFunctions; version=%d",
		 *interfaceVersion);
  if (!pengfuncsFromEngine)
    {
      LOG_ERROR (PLID,
		 "GetEngineFunctions called with null pengfuncsFromEngine");
      return (FALSE);
    }
  else if (*interfaceVersion != ENGINE_INTERFACE_VERSION)
    {
      LOG_ERROR (PLID,
		 "GetEngineFunctions version mismatch; requested=%d ours=%d",
		 *interfaceVersion, ENGINE_INTERFACE_VERSION);
      // Tell metamod what version we had, so it can figure out who is out of date.
      *interfaceVersion = ENGINE_INTERFACE_VERSION;
      return (FALSE);
    }
  memset (&meta_engfuncs, 0, sizeof (meta_engfuncs));

	meta_engfuncs.pfnMessageBegin = MessageBegin;
	meta_engfuncs.pfnMessageEnd = MessageEnd;
	meta_engfuncs.pfnWriteByte = WriteByte;
	meta_engfuncs.pfnWriteChar = WriteChar;
	meta_engfuncs.pfnWriteShort = WriteShort;
	meta_engfuncs.pfnWriteLong = WriteLong;
	meta_engfuncs.pfnWriteAngle = WriteAngle;
	meta_engfuncs.pfnWriteCoord = WriteCoord;
	meta_engfuncs.pfnWriteString = WriteString;
	meta_engfuncs.pfnWriteEntity =  WriteEntity;

  memcpy (pengfuncsFromEngine, &meta_engfuncs, sizeof (enginefuncs_t));


  return TRUE;
}

enginefuncs_t meta_engfuncs_post;
C_DLLEXPORT int
GetEngineFunctions_Post (enginefuncs_t * pengfuncsFromEngine,
			 int *interfaceVersion)
{
  LOG_DEVELOPER (PLID, "called: GetEngineFunctions; version=%d",
		 *interfaceVersion);
  if (!pengfuncsFromEngine)
    {
      LOG_ERROR (PLID,
		 "GetEngineFunctions called with null pengfuncsFromEngine");
      return (FALSE);
    }
  else if (*interfaceVersion != ENGINE_INTERFACE_VERSION)
    {
      LOG_ERROR (PLID,
		 "GetEngineFunctions version mismatch; requested=%d ours=%d",
		 *interfaceVersion, ENGINE_INTERFACE_VERSION);
      // Tell metamod what version we had, so it can figure out who is out of date.
      *interfaceVersion = ENGINE_INTERFACE_VERSION;
      return (FALSE);
    }
  memcpy (pengfuncsFromEngine, &meta_engfuncs_post, sizeof (enginefuncs_t));
  return TRUE;
}
